import type { FunctionComponent, PropsWithChildren } from 'react';
import type { CodeMirror, GetView, ProvidedCodeMirrorConfig, UseContainerRefHook, UseViewDispatchHook, UseViewEffectHook, UseViewHook } from './types.js';
export interface CodeMirrorProps {
    config?: ProvidedCodeMirrorConfig;
}
export interface CodeMirrorProviderProps extends PropsWithChildren<CodeMirrorProps> {
}
export interface CodeMirrorProvider extends FunctionComponent<CodeMirrorProviderProps> {
}
export type UseCodeMirrorContextHook<ContainerElement extends Element = Element> = () => CodeMirror<ContainerElement>;
export type UseGetViewHook = () => GetView;
export interface CodeMirrorWithContext<ContainerElement extends Element = Element> {
    Provider: CodeMirrorProvider;
    useContext: UseCodeMirrorContextHook<ContainerElement>;
    useGetView: UseGetViewHook;
    useView: UseViewHook;
    useViewEffect: UseViewEffectHook;
    useViewDispatch: UseViewDispatchHook;
    useContainerRef: UseContainerRefHook<ContainerElement>;
}
export declare function createCodeMirrorWithContext<ContainerElement extends Element>(displayName?: string | false): CodeMirrorWithContext<ContainerElement>;
//# sourceMappingURL=context.d.ts.map